PFont font1 = createFont("Helvetica", 12);

int[][] transactionsPerMonth = new int[4][12];
String[] whichMonth = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};

int minCount = 0;
int maxCount = 12;

int sumOfxpos = 130;
int sumOfypos = 550;

int whichData = 0;

void setup(){
  size(880,680);
  textFont(font1);
  textAlign(CENTER);
  colorMode(HSB, 360);
  smooth();
  
  String savedData[] = loadStrings("savedData.txt");
  for (int i=1; i < savedData.length; i++) {
    String temp[] = split(savedData[i], ",");
    transactionsPerMonth[int((i-1)/12)][Integer.parseInt(temp[0])-1] = Integer.parseInt(temp[1]);
  } 
}

void draw(){
  background(0, 0, 360);
   
  noStroke();        
    fill(209,59*3.6,85*3.6,250); 
    ellipse(25, height/2 - 25,  15, 15);
      fill(100);
      text("Query #1 [key 1]", 80, height/2 - 20); 
    fill(343,65*3.6,100*3.6,250);
    ellipse(25, height/2,  15, 15);
      fill(100);
      text("Query #2 [key 2]", 80, height/2 + 4);  
    fill(275,41*3.6,75*3.6,250); 
    ellipse(25, height/2 + 25,  15, 15); 
      fill(100);
      text("Query #3 [key 3]", 80, height/2 + 28);

  //Draw curve
  drawCurve();
  stroke(0);
  
  //Draw top lines
  strokeWeight(0.5);
  line(0, 100, 880, 100);
  
  //Draw bottom line
  line(0, sumOfypos, width, sumOfypos);
  
  for(int i = minCount; i < maxCount; i++){
    strokeWeight(0.5);
    //Draw month lines
    stroke(0,50);
    strokeWeight(1);
    line((54 * i) + 235, 100, (54 * i) + 235, sumOfypos);
    //Display month
    fill(0);
    stroke(0);
    textSize(12);
    text(whichMonth[i], (54 * i) + 225, 95); 
  }
  
  for(int i = 0; i < 3; i++){
    for(int j = 0; j < 12; j++){
                       
      //Dots with value   
      strokeWeight(2.5);
      if ( i == 0 ){
        noStroke();
        fill(209,59*3.6,85*3.6,transactionsPerMonth[0][j] * 10.0); 
        ellipse((54 * j) + 235, height/2 - 25,  15, 15);
      } else if ( i == 1 ) {
          noStroke();
          fill(343,65*3.6,100*3.6,transactionsPerMonth[1][j] * 10.0); 
          ellipse((54 * j) + 235, height/2,  15, 15);
      } else if ( i == 2 ) {
          noStroke();
          fill(275,41*3.6,75*3.6,transactionsPerMonth[2][j] * 10.0); 
          ellipse((54 * j) + 235, height/2 + 25,  15, 15);
      }
      fill(0);
      stroke(0);
      
      //Rollover
      float tempX = (54 * j) + 235;
      float tempY0 = height/2 - 25;
        if (abs(mouseX - tempX) < (7.5) && abs(mouseY - tempY0) < (7.5)){
        textSize(12);
        textAlign(LEFT);
        fill(0,100);
        stroke(0);
        text(transactionsPerMonth[0][j] + " total transactions in " + whichMonth[j] + " from 2005 to 2011", 25, 605);
        }        
      float tempY1 = height/2;
        if (abs(mouseX - tempX) < (7.5) && abs(mouseY - tempY1) < (7.5)){
        textSize(12);
        textAlign(LEFT);
        fill(0,100);
        stroke(0);
        text(transactionsPerMonth[1][j] + " total transactions in " + whichMonth[j] + " from 2005 to 2011", 25, 605);
        }  
      float tempY2 = height/2 + 25;
        if (abs(mouseX - tempX) < (7.5) && abs(mouseY - tempY2) < (7.5)){
        textSize(12);
        textAlign(LEFT);
        fill(0,100);
        stroke(0);
        text(transactionsPerMonth[2][j] + " total transactions in " + whichMonth[j] + " from 2005 to 2011", 25, 605);
        }  
    }
  }
  
  if (whichData == 0){
    textSize(12);
    fill(0);
    stroke(0);
    textAlign(LEFT);
    text("Query #1: The Catcher In The Rye, Holden Coulfield ", 25, 580);
    textAlign(CENTER);  
  }
  else if (whichData == 1){
    textSize(12);
    fill(0);
    stroke(0);
    textAlign(LEFT);
    text("Query #2: Isaac Asimov, Aum Shinrikyo ", 25, 580);
    textAlign(CENTER);
  }
  else if (whichData == 2){
    textSize(12);
    fill(0);
    stroke(0);
    textAlign(LEFT);
    text("Query #3: The Secret Agent, Joseph Conrad, Unabomber", 25, 580);
    textAlign(CENTER);
  }
}

void drawCurve(){
    if ( whichData == 0 ){
    stroke(209,59*3.6,85*3.6,80); 
    noFill();
    strokeWeight(5);
    beginShape();
    curveVertex((54 * 0) + 235,(transactionsPerMonth[0][0] * -6.0) + sumOfypos - 100);
    for(int i = 0; i < 1; i++){
      for(int j = 0; j < 12; j++){
    float x = (54 * j) + 235;
    float y = (transactionsPerMonth[0][j] * -6.0) + sumOfypos - 100;
    curveVertex(x,y);
      }
    }
    curveVertex((54 * 11) + 235,(transactionsPerMonth[0][11] * -6.0) + sumOfypos - 100);
    endShape();
  }
    if ( whichData == 1 ){
    stroke(343,65*3.6,100*3.6,80); 
    noFill();
    strokeWeight(5);
    beginShape();
    curveVertex((54 * 0) + 235,(transactionsPerMonth[1][0] * -6.0) + sumOfypos - 100);
    for(int i = 0; i < 1; i++){
      for(int j = 0; j < 12; j++){
    float x = (54 * j) + 235;
    float y = (transactionsPerMonth[1][j] * -6.0) + sumOfypos - 100;
    curveVertex(x,y);
      }
    }
    curveVertex((54 * 11) + 235,(transactionsPerMonth[1][11] * -6.0) + sumOfypos - 100);
    endShape();
  }
    if ( whichData == 2 ){
    stroke(275,41*3.6,75*3.6,80); 
    noFill();
    strokeWeight(5);
    beginShape();
    curveVertex((54 * 0) + 235,(transactionsPerMonth[2][0] * -6.0) + sumOfypos - 100);
    for(int i = 0; i < 1; i++){
      for(int j = 0; j < 12; j++){
    float x = (54 * j) + 235;
    float y = (transactionsPerMonth[2][j] * -6.0) + sumOfypos - 100;
    curveVertex(x,y);
      }
    }
    curveVertex((54 * 11) + 235,(transactionsPerMonth[2][11] * -6.0) + sumOfypos - 100);
    endShape();
  }
}


void keyPressed(){
  if (key == '1'){
    whichData = 0;
  }

  if (key == '2'){
    whichData = 1;
  }

  if (key == '3'){
    whichData = 2;
  }
}
